#!/bin/bash
# this script assumes you are in the Clients directory already

cp_files="proc/cpuinfo proc/devices proc/meminfo proc/modules proc/partitions proc/swaps"
tar_files="/boot/etc/yaboot.conf etc/fstab etc/hosts etc/inittab etc/iproute2 etc/nsswitch.conf etc/rc.local etc/sysctl.conf etc/rc.d/rc3.d/ etc/rc.d/init.d/ var/log/dmesg"

phys_client=9.3.105.182
phys_client2=9.3.105.161
vm_client_list="tile1c1 tile2c1 tile3c1 tile4c1 tile5c1 tile6c1 tile7c1 tile8c1 tile9c1 tile10c1 tile11c1 tile12c1 tile13c1 tile14c1 tile15c1"

do_phys_client()
{
echo "phys_client is $phys_client"
mkdir -p $phys_client
pushd $phys_client
tar_files_aix='/etc/hosts /etc/inittab /etc/netsvc.conf /etc/security/limits /etc/rc* /etc/security/limits /etc/tunables/lastboot /etc/tunables/nextboot'
hostname=`ssh $phys_client hostname`

ssh $phys_client   ifconfig en0 > ifconfig_en0.out
ssh $phys_client   ifconfig -a > ifconfig.txt
ssh $phys_client   lssrc -h $hostname -a > lssrc.out
ssh $phys_client   lspath > lspath.out
ssh $phys_client    "cd /; tar chf - $tar_files_aix" | tar xf -
ssh $phys_client    /usr/sbin/lssrad -av > lssrad_av.out 2>&1
ssh $phys_client    /usr/sbin/lsrset -av > lsrset.out 2>&1

ssh $phys_client    netstat -in > netstat_in.out
ssh $phys_client    netstat -m > netstat_m.out
ssh $phys_client    netstat -v > netstat_v.out
ssh $phys_client    netstat -r > netstat_r.out
ssh $phys_client    /usr/sbin/mount > mount.out 2>&1
ssh $phys_client    oslevel -s > oslevel.out 2>&1
ssh $phys_client    lslpp -l all > lslpp_All.out 2>&1
ssh $phys_client    cat /etc/security/limits > limits.out 2>&1
ssh $phys_client    cat /etc/tunables/lastboot > tunables_lastboot.out 2>&1
ssh $phys_client    cat /etc/tunables/nextboot > tunables_nextboot.out 2>&1
ssh $phys_client    vmo -FL > tunable.out 2>&1
ssh $phys_client    ioo -FL >> tunable.out 2>&1
ssh $phys_client    schedo -FL >> tunable.out 2>&1
ssh $phys_client    no -FL >> tunable.out 2>&1
ssh $phys_client    nfso -FL >> tunable.out 2>&1
ssh $phys_client    prtconf > prtconf.out 2>&1
ssh $phys_client    lsfs -q > lsfs.out 2>&1
ssh $phys_client    df -m > df.out 2>&1
ssh $phys_client    lscfg -vp > lscfg.out 2>&1
ssh $phys_client    lsdev -Cc adapter > lsdev_adapter.out 2>&1
ssh $phys_client    lsdev -Cc disk > lsdev_disk.out 2>&1
ssh $phys_client    lspv > lspv.out 2>&1
ssh $phys_client    vmstat -v > vmstat_v.out 2>&1
ssh $phys_client    lparstat -i > lparstat.out 2>&1
num_tiles=7
for tile in `seq 1 $num_tiles`; do
    zpt=`printf "%02d" $tile`
    for type in c1; do
ssh hscpe@perf2811.austin.ibm.com "lssyscfg -r lpar -m virtmrfofsp2 --filter "lpar_names=tile$tile$type"" >> lpar_config.out
ssh hscpe@perf2811.austin.ibm.com "lssyscfg -r prof -m virtmrfofsp2 --filter "lpar_names=tile$tile$type","profile_names=normal"" >> lpar_profile.out
done
done
ssh hscpe@perf2811.austin.ibm.com "lssyscfg -r lpar -m virtmrfofsp2 --filter "lpar_names=VIOS1"" >> lpar_config.out
ssh hscpe@perf2811.austin.ibm.com "lssyscfg -r prof -m virtmrfofsp2 --filter "lpar_names=VIOS1","profile_names=normal"" >> lpar_profile.out

popd >/dev/null
}

do_phys_client2()
{
echo "phys_client2 is $phys_client2"
mkdir -p $phys_client2
pushd $phys_client2
tar_files_aix='/etc/hosts /etc/inittab /etc/netsvc.conf /etc/security/limits /etc/rc* /etc/security/limits /etc/tunables/lastboot /etc/tunables/nextboot'
hostname=`ssh $phys_client hostname`

ssh $phys_client2   ifconfig en4 > ifconfig_en4.out
ssh $phys_client2   ifconfig -a > ifconfig.txt
ssh $phys_client2   lssrc -h $hostname -a > lssrc.out
ssh $phys_client2   lspath > lspath.out
ssh $phys_client2    "cd /; tar chf - $tar_files_aix" | tar xf -
ssh $phys_client2    /usr/sbin/lssrad -av > lssrad_av.out 2>&1
ssh $phys_client2    /usr/sbin/lsrset -av > lsrset.out 2>&1

ssh $phys_client2    netstat -in > netstat_in.out
ssh $phys_client2    netstat -m > netstat_m.out
ssh $phys_client2    netstat -v > netstat_v.out
ssh $phys_client2    netstat -r > netstat_r.out
ssh $phys_client2    /usr/sbin/mount > mount.out 2>&1
ssh $phys_client2    oslevel -s > oslevel.out 2>&1
ssh $phys_client2    lslpp -l all > lslpp_All.out 2>&1
ssh $phys_client2    cat /etc/security/limits > limits.out 2>&1
ssh $phys_client2    cat /etc/tunables/lastboot > tunables_lastboot.out 2>&1
ssh $phys_client2    cat /etc/tunables/nextboot > tunables_nextboot.out 2>&1
ssh $phys_client2    vmo -FL > tunable.out 2>&1
ssh $phys_client2    ioo -FL >> tunable.out 2>&1
ssh $phys_client2    schedo -FL >> tunable.out 2>&1
ssh $phys_client2    no -FL >> tunable.out 2>&1
ssh $phys_client2    nfso -FL >> tunable.out 2>&1
ssh $phys_client2    prtconf > prtconf.out 2>&1
ssh $phys_client2    lsfs -q > lsfs.out 2>&1
ssh $phys_client2    df -m > df.out 2>&1
ssh $phys_client2    lscfg -vp > lscfg.out 2>&1
ssh $phys_client2   lsdev -Cc adapter > lsdev_adapter.out 2>&1
ssh $phys_client2    lsdev -Cc disk > lsdev_disk.out 2>&1
ssh $phys_client2    lspv > lspv.out 2>&1
ssh $phys_client2    vmstat -v > vmstat_v.out 2>&1
ssh $phys_client2    lparstat -i > lparstat.out 2>&1
num_tiles=15
for tile in `seq 8 $num_tiles`; do
    zpt=`printf "%02d" $tile`
    for type in c1; do
ssh hscpe@perf2811.austin.ibm.com "lssyscfg -r lpar -m virtmrfofsp1 --filter "lpar_names=tile$tile$type"" >> lpar_config.out
ssh hscpe@perf2811.austin.ibm.com "lssyscfg -r prof -m virtmrfofsp1 --filter "lpar_names=tile$tile$type","profile_names=normal"" >> lpar_profile.out
done
done
ssh hscpe@perf2811.austin.ibm.com "lssyscfg -r lpar -m virtmrfofsp1 --filter "lpar_names=VIOS1"" >> lpar_config.out
ssh hscpe@perf2811.austin.ibm.com "lssyscfg -r prof -m virtmrfofsp1 --filter "lpar_names=VIOS1","profile_names=normal"" >> lpar_profile.out

popd >/dev/null
}

do_vm_controller()
{
	vm_client=client1
	mkdir -p $vm_client
	pushd $vm_client
	ssh $vm_client "cd /; tar chf - $tar_files" | tar xf -
	mkdir ./proc
	for file in $cp_files; do
 	    ssh $vm_client cat /$file >./$file
	done
	ssh $vm_client ifconfig -a >ifconfig.txt
	ssh $vm_client chkconfig --list >chkconfig.txt
	ssh $vm_client mount -l >mount.txt
	ssh $vm_client df >df.txt
	ssh $vm_client lspci >lspci.txt
	ssh $vm_client rpm -qa >rpmpkgs.txt
    popd >/dev/null
}
do_vm_client()
{
    vm_clients=`echo $phys_client_and_vms | sed -e s/"^${phys_client}:"//`
    for vm_client in $vm_client_list; do
	echo "  vm_client is $vm_client"
	#zpt=`echo $vm_client | sed -e s/"^${prefix}${client}t"//`
	sub_dir=`echo $vm_client | sed 's/c[1-2]//'`
	mkdir -p $sub_dir
pushd $sub_dir
	mkdir -p $vm_client
	pushd $vm_client
	ssh $vm_client "cd /; tar chf - $tar_files" | tar xf -
	mkdir ./proc
	for file in $cp_files; do
 	    ssh $vm_client cat /$file >./$file
	done
	ssh $vm_client ifconfig -a >ifconfig.txt
	ssh $vm_client chkconfig --list >chkconfig.txt
	ssh $vm_client mount -l >mount.txt
	ssh $vm_client df >df.txt
	ssh $vm_client lspci >lspci.txt
	ssh $vm_client rpm -qa >rpmpkgs.txt
	popd >/dev/null
	popd >/dev/null
    done
    popd >/dev/null
}

do_phys_client
do_phys_client2
do_vm_controller
do_vm_client
