#!/bin/bash
# script assumes you are in the Virtual_Configuration subdir

#. /root/specvirt_vars.sh

num_tiles=$1
#sut=${prefix}${host}
#cp_files='proc/cpuinfo proc/devices proc/meminfo proc/modules proc/partitions proc/swaps proc/mounts proc/version proc/mounts proc/cmdline'
#tar_files='/boot/etc/yaboot.conf etc/fstab etc/hosts etc/inittab etc/iproute2 etc/nsswitch.conf etc/sysctl.conf etc/security/limits* etc/modprobe* etc/rc.d/rc3.d/ etc/rc.d/rc.local etc/rc.d/init.d/ var/log/dmesg'

do_linux_data_collection()
{
cp_files='proc/cpuinfo proc/devices proc/meminfo proc/modules proc/partitions proc/swaps proc/mounts proc/version proc/mounts proc/cmdline'
tar_files='/boot/etc/yaboot.conf etc/fstab etc/hosts etc/inittab etc/iproute2 etc/nsswitch.conf etc/sysctl.conf etc/security/limits* etc/modprobe* etc/rc.d/rc3.d/ etc/rc.d/rc.local etc/rc.d/init.d/ var/log/dmesg'
        dir="${vmtype}server"
        mkdir -p $dir
        pushd $dir >/dev/null
        mkdir -p VM_configuration
        pushd VM_configuration
        ssh $server "cd /; tar chf - $tar_files" | tar xf -
        mkdir -p ./proc
        for file in $cp_files; do
            ssh $server cat /$file >./$file
        done
        ssh $server ifconfig -a >ifconfig.txt
        ssh $server chkconfig --list >chkconfig.txt
        ssh $server mount -l >mount.txt
        ssh $server df >df.txt
        ssh $server lspci >lspci.txt
        ssh $server rpm -qa >rpmpkgs.txt
        ssh $server tuned-adm active  >tuned-adm.txt
        popd >/dev/null # VM_configuration
}

do_aix_data_collection()
{
dir="${vmtype}server"
mkdir -p $dir
pushd $dir >/dev/null
mkdir -p VM_configuration
pushd VM_configuration
tar_files='/etc/hosts /etc/inittab /etc/netsvc.conf /etc/security/limits /etc/rc* /etc/security/limits /etc/tunables/lastboot /etc/tunables/nextboot'
hostname=`ssh $server hostname`

ssh $server   ifconfig en0 > ifconfig_en0.out
ssh $server   ifconfig en1 > ifconfig_en1.out
ssh $server   ifconfig -a > ifconfig.txt
ssh $server    netstat -in > netstat_in.out
ssh $server    netstat -m > netstat_m.out
ssh $server    netstat -v > netstat_v.out
ssh $server    netstat -s > netstat_s.out
ssh $server    netstat -r > netstat_r.out
ssh $server    "cd /; tar chf - $tar_files" | tar xf -
ssh $server    /usr/sbin/mount > mount.out 2>&1
ssh $server    /usr/sbin/lssrad -av > lssrad_av.out 2>&1
ssh $server    /usr/sbin/lsrset -av > lsrset.out 2>&1
ssh $server    oslevel -s > oslevel.out 2>&1
ssh $server    lslpp -l all > lslpp_All.out 2>&1
ssh $server    ioo -FL >> tunable.out 2>&1
ssh $server    no -FL >> tunable.out 2>&1
ssh $server    prtconf > prtconf.out 2>&1
ssh $server    lsfs -q > lsfs.out 2>&1
ssh $server    df -m > df.out 2>&1
ssh $server    lspath > lspath.out
ssh $server    lscfg -vp > lscfg.out 2>&1
ssh $server    lsdev -Cc adapter > lsdev_adapter.out 2>&1
ssh $server    lsdev -Cc disk > lsdev_disk.out 2>&1
ssh $server    lspv > lspv.out 2>&1
ssh $server    alog -o -t boot > bootlog.out 2>&1
ssh $server    alog -o -t cfg > cfglog.out 2>&1
ssh $server    vmstat -v > vmstat_v.out 2>&1
ssh $server    lparstat -i > lparstat.out 2>&1
popd >/dev/null # VM_configuration
}

#cp -rp /root/sc2013_pub/Collection_scripts .

for tile in `seq 1 $num_tiles`; do
    zpt=`printf "%02d" $tile`
    mkdir -p tile$tile
    pushd tile$tile >/dev/null
    for vmtype in web app db batch infra mail; do
        if [ "$vmtype" = "db" ]; then
            rest=$[$tile%4]
            if [ "$rest" != 1 ]; then
                continue
            fi
        fi           
        case $vmtype in
	    "web")
server=tile${tile}p1
echo "server" $server
do_linux_data_collection
mkdir -p Software_Configuration
pushd Software_Configuration >/dev/null
	    mkdir -p httpd
            ssh $server /opt/freeware/apache2/bin/httpd -version > ./httpd/httpd.version
	    scp -r $server:/etc/httpd/conf ./httpd/
	    scp -r $server:/etc/httpd/conf.d ./httpd/
	    mkdir -p php
	    scp -r $server:/etc/php.ini ./php/
	    scp -r $server:/etc/php.d ./php/
popd >/dev/null #Software_Configuration
popd >/dev/null #tile#
	    ;;
	    "app")
server=tile${tile}p5
do_linux_data_collection
mkdir -p Software_Configuration
pushd Software_Configuration >/dev/null

	        mkdir -p specjapp
	          scp $server:/was8/profiles/specjapp/config/cells/appserverNode01Cell/nodes/appserverNode01/servers/server1/server.xml ./specjapp/server.xml
popd >/dev/null #Software_Configuration
popd >/dev/null #tile#
	    ;;
	    "db")
server=tile${tile}p6
do_aix_data_collection
mkdir -p Software_Configuration
pushd Software_Configuration >/dev/null
	    scp $server:/home/db2inst1/sqllib/db2nodes.cfg .
	    scp $server:/home/db2inst1/sqllib/profile.env .
popd >/dev/null #Software_Configuration
popd >/dev/null #tile#
	    ;;
	    "infra")
server=tile${tile}p2
do_aix_data_collection
mkdir -p Software_Configuration
pushd Software_Configuration >/dev/null
	    scp $server:/etc/exports exports
	    mkdir -p httpd
            ssh $server /opt/freeware/apache2/bin/httpd -version > ./httpd/httpd.version
	    scp -r $server:/opt/freeware/apache2/conf ./httpd/
	    #scp -r $server:/etc/httpd/conf.d ./httpd/
popd >/dev/null #Software_Configuration
popd >/dev/null #tile#
	    ;;
	    "mail")
server=tile${tile}p3
do_linux_data_collection
mkdir -p Software_Configuration
pushd Software_Configuration >/dev/null
	    scp $server:/opt/freeware/dovecot/etc/dovecot/dovecot.conf .
popd >/dev/null #Software_Configuration
popd >/dev/null #tile#
	    ;;
	    "batch")
server=tile${tile}p4
do_aix_data_collection
mkdir -p Software_Configuration
popd >/dev/null #tile#
	    ;;
        esac
#        popd >/dev/null  # Software_Configuration
        #popd >/dev/null  # $dir
    done
    popd >/dev/null
done
